net.sf.saxon.option.xom

## Class XOMDocumentWrapper

- java.lang.Object
- - net.sf.saxon.tree.wrapper.AbstractNodeWrapper
  - - net.sf.saxon.option.xom.XOMNodeWrapper
    - - net.sf.saxon.option.xom.XOMDocumentWrapper

- All Implemented Interfaces:
    Source, PullEvent, DocumentInfo, Item, NodeInfo, Sequence, SteppingNode, SiblingCountingNode, VirtualNode

      public class XOMDocumentWrapper
      extends XOMNodeWrapper
      implements DocumentInfo

  The root node of an XPath tree. (Or equivalently, the tree itself).

  This class is used not only for a document, but also for the root of a document-less tree fragment.

  Author:
    Michael H. Kay, Wolfgang Hoschek (ported net.sf.saxon.jdom to XOM)

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected String` | `baseURI`
    `protected Configuration` | `config`
    `protected long` | `documentNumber`

    - ### Fields inherited from class net.sf.saxon.option.xom.XOMNodeWrapper

      `docWrapper, index, node, nodeKind`

    - ### Fields inherited from interface net.sf.saxon.om.NodeInfo

      `ALL_NAMESPACES, IS_DTD_TYPE, IS_NILLED, LOCAL_NAMESPACES, NO_NAMESPACES`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `XOMDocumentWrapper(Node root, String baseURI, Configuration config)` Create a Saxon wrapper for a XOM root node

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `Configuration` | `getConfiguration()` Get the configuration previously set using setConfiguration
    `long` | `getDocumentNumber()` Get the unique document number for this document (the number is unique for all documents within a NamePool)
    `NamePool` | `getNamePool()` Get the name pool used for the names in this document
    `SchemaType` | `getSchemaType()` Get the type annotation of this node, if any.
    `int` | `getTypeAnnotation()` Get the type annotation of this node, if any.
    `String[]` | `getUnparsedEntity(String name)` Get the unparsed entity with a given name
    `Iterator<String>` | `getUnparsedEntityNames()` Get the list of unparsed entities defined in this document
    `Object` | `getUserData(String key)` Get user data held in the document node.
    `boolean` | `isTyped()` Ask whether the document contains any nodes whose type annotation is anything other than UNTYPED
    `NodeInfo` | `selectID(String id, boolean getParent)` Get the element with a given ID, if any
    `void` | `setConfiguration(Configuration config)` Set the configuration, which defines the name pool used for all names in this document.
    `void` | `setUserData(String key, Object value)` Set user data on the document node.
    `NodeInfo` | `wrap(Node node)` Wrap a node in the XOM document.

    - ### Methods inherited from class net.sf.saxon.option.xom.XOMNodeWrapper

      `atomize, compareOrder, comparePosition, copy, delete, equals, generateId, getAttributeValue, getBaseURI, getColumnNumber, getDeclaredNamespaces, getDisplayName, getDocumentRoot, getFingerprint, getFirstChild, getLineNumber, getLocalPart, getNameCode, getNextSibling, getNodeKind, getParent, getPrefix, getPreviousSibling, getRoot, getSiblingPosition, getStringValue, getStringValueCS, getSuccessorElement, getSystemId, getUnderlyingNode, getURI, hasChildNodes, hashCode, isId, isIdref, isNilled, isSameNodeInfo, iterate, iterateAttributes, iterateChildren, iterateDescendants, iterateSiblings, makeWrapper, makeWrapper, setSystemId`

    - ### Methods inherited from class net.sf.saxon.tree.wrapper.AbstractNodeWrapper

      `getRealNode, head, iterateAxis, iterateAxis`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.om.NodeInfo

      `atomize, compareOrder, comparePosition, copy, equals, generateId, getAttributeValue, getBaseURI, getColumnNumber, getDeclaredNamespaces, getDisplayName, getDocumentRoot, getFingerprint, getLineNumber, getLocalPart, getNameCode, getNodeKind, getParent, getPrefix, getRoot, getStringValue, getSystemId, getURI, hasChildNodes, hashCode, isId, isIdref, isNilled, isSameNodeInfo, iterateAxis, iterateAxis`

    - ### Methods inherited from interface javax.xml.transform.Source

      `setSystemId`

    - ### Methods inherited from interface net.sf.saxon.om.Item

      `getStringValueCS`

    - ### Methods inherited from interface net.sf.saxon.om.Sequence

      `head, iterate`

    - ### Methods inherited from interface net.sf.saxon.tree.wrapper.VirtualNode

      `getRealNode`

- - ### Field Detail

    - #### config

          protected Configuration config

    - #### baseURI

          protected String baseURI

    - #### documentNumber

          protected long documentNumber

  - ### Constructor Detail

    - #### XOMDocumentWrapper

          public XOMDocumentWrapper(Node root,
                            String baseURI,
                            Configuration config)

      Create a Saxon wrapper for a XOM root node
      Parameters:
        `root` - The XOM root node
        `baseURI` - The base URI for all the nodes in the tree
        `config` - The configuration which defines the name pool used for all names in this tree

  - ### Method Detail

    - #### wrap

          public NodeInfo wrap(Node node)

      Wrap a node in the XOM document.
      Parameters:
        `node` - The node to be wrapped. This must be a node in the same document (the system does not check for this).
      Returns:
        the wrapping NodeInfo object

    - #### setConfiguration

          public void setConfiguration(Configuration config)

      Set the configuration, which defines the name pool used for all names in this document. This is always called after a new document has been created. The implementation must register the name pool with the document, so that it can be retrieved using getNamePool(). It must also call NamePool.allocateDocumentNumber(), and return the relevant document number when getDocumentNumber() is subsequently called.
      Parameters:
        `config` - The configuration to be used

    - #### getConfiguration

          public Configuration getConfiguration()

      Get the configuration previously set using setConfiguration
      Specified by:
        `getConfiguration` in interface `NodeInfo`
      Overrides:
        `getConfiguration` in class `XOMNodeWrapper`
      Returns:
        the Configuration

    - #### getNamePool

          public NamePool getNamePool()

      Get the name pool used for the names in this document
      Specified by:
        `getNamePool` in interface `NodeInfo`
      Overrides:
        `getNamePool` in class `XOMNodeWrapper`
      Returns:
        the name pool in which all the names used in this document are registered

    - #### isTyped

          public boolean isTyped()

      Ask whether the document contains any nodes whose type annotation is anything other than UNTYPED
      Specified by:
        `isTyped` in interface `DocumentInfo`
      Returns:
        true if the document contains elements whose type is other than UNTYPED

    - #### getDocumentNumber

          public long getDocumentNumber()

      Get the unique document number for this document (the number is unique for all documents within a NamePool)
      Specified by:
        `getDocumentNumber` in interface `NodeInfo`
      Overrides:
        `getDocumentNumber` in class `XOMNodeWrapper`
      Returns:
        the unique number identifying this document within the name pool

    - #### selectID

          public NodeInfo selectID(String id,
                          boolean getParent)

      Get the element with a given ID, if any
      Specified by:
        `selectID` in interface `DocumentInfo`
      Parameters:
        `id` - the required ID value
        `getParent` -
      Returns:
        the element with the given ID, or null if there is no such ID present (or if the parser has not notified attributes as being of type ID).

    - #### getUnparsedEntityNames

          public Iterator<String> getUnparsedEntityNames()

      Get the list of unparsed entities defined in this document
      Specified by:
        `getUnparsedEntityNames` in interface `DocumentInfo`
      Returns:
        an Iterator, whose items are of type String, containing the names of all unparsed entities defined in this document. If there are no unparsed entities or if the information is not available then an empty iterator is returned

    - #### getUnparsedEntity

          public String[] getUnparsedEntity(String name)

      Get the unparsed entity with a given name
      Specified by:
        `getUnparsedEntity` in interface `DocumentInfo`
      Parameters:
        `name` - the name of the entity
      Returns:
        null: XOM does not provide access to unparsed entities

    - #### getTypeAnnotation

          public int getTypeAnnotation()

      Get the type annotation of this node, if any. Returns -1 for kinds of nodes that have no annotation, and for elements annotated as untyped, and attributes annotated as untypedAtomic.
      Specified by:
        `getTypeAnnotation` in interface `NodeInfo`
      Overrides:
        `getTypeAnnotation` in class `XOMNodeWrapper`
      Returns:
        the type annotation of the node.
      See Also:
        `Type`

    - #### getSchemaType

          public SchemaType getSchemaType()

      Get the type annotation of this node, if any. The type annotation is represented as SchemaType object.

      Types derived from a DTD are not reflected in the result of this method.

      Specified by:
        `getSchemaType` in interface `NodeInfo`
      Overrides:
        `getSchemaType` in class `XOMNodeWrapper`
      Returns:
        For element and attribute nodes: the type annotation derived from schema validation (defaulting to xs:untyped and xs:untypedAtomic in the absence of schema validation). For comments, text nodes, processing instructions, and namespaces: null. For document nodes, either xs:untyped if the document has not been validated, or xs:anyType if it has.
      Since:
        9.4

    - #### setUserData

          public void setUserData(String key,
                         Object value)

      Set user data on the document node. The user data can be retrieved subsequently using `getUserData(java.lang.String)`
      Specified by:
        `setUserData` in interface `DocumentInfo`
      Parameters:
        `key` - A string giving the name of the property to be set. Clients are responsible for choosing a key that is likely to be unique. Must not be null. Keys used internally by Saxon are prefixed "saxon:".
        `value` - The value to be set for the property. May be null, which effectively removes the existing value for the property.

    - #### getUserData

          public Object getUserData(String key)

      Get user data held in the document node. This retrieves properties previously set using `setUserData(java.lang.String, java.lang.Object)`
      Specified by:
        `getUserData` in interface `DocumentInfo`
      Parameters:
        `key` - A string giving the name of the property to be retrieved.
      Returns:
        the value of the property, or null if the property has not been defined.

Copyright (c) 2004-2013 Saxonica Limited. All rights reserved.